#!/bin/bash

# Set Raspberry Pi's master volume to 100%.
#
amixer set 'PCM' 100%

# Make Debugcomvette the current directory.
#
cd /home/pi/Desktop/Debugcomvette/

# Delete any orphaned .dat files.
#
rm -f launch_music.dat
rm -f launch_movie.dat

# Kill previously running audio and video launchers.
#
killall launch_music.sh
killall launch_movie.sh

# Run the audio and video launchers as background processes.
#
./launch_music.sh &
./launch_movie.sh &

# Run the Debugcomvette program.
#
./Debugcomvette &
