#tag Class
Protected Class amplifier_mgr
	#tag Method, Flags = &h0
		Sub Constructor()
		  
		  ' The BOSE speaker amplifiers are either ON or OFF based on GPIO input. The default
		  ' state is OFF.
		  '
		  ' To turn the amplifiers ON, the GPIO pin driving the amplifier control relay must be ON.
		  '
		  ' To turn the amplifiers OFF, the GPIO pin driving the amplifier control relay must be OFF.
		  '
		  
		  
		  ' Set the BOSE amplifier relay GPIO pin to act as an output.
		  '
		  GPIO.PinMode(gintConfig_PinAmplifier, GPIO.OUTPUT)
		  
		  ' Turn the BOSE speaker amplifier relay OFF.
		  '
		  GPIO.DigitalWrite(gintConfig_PinAmplifier, GPIO.OFF)
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Destructor()
		  
		  ' Turn the BOSE speaker amplifier relay OFF.
		  '
		  GPIO.DigitalWrite(gintConfig_PinAmplifier, GPIO.OFF)
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub OFF()
		  
		  GPIO.DigitalWrite(gintConfig_PinAmplifier, GPIO.OFF)
		  
		  System.DebugLog("Amp:OFF")
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub ON()
		  
		  GPIO.DigitalWrite(gintConfig_PinAmplifier, GPIO.ON)
		  
		  System.DebugLog("Amp:ON")
		  
		End Sub
	#tag EndMethod


	#tag ViewBehavior
		#tag ViewProperty
			Name="Index"
			Visible=true
			Group="ID"
			InitialValue="-2147483648"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Left"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Name"
			Visible=true
			Group="ID"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Super"
			Visible=true
			Group="ID"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Top"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
	#tag EndViewBehavior
End Class
#tag EndClass
