#tag Class
Protected Class antenna_mgr
	#tag Method, Flags = &h0
		Sub Constructor()
		  
		  ' The electric antenna is either Extended or Retracted based on GPIO input. Its default
		  ' state is retracted.
		  '
		  ' To Extend the antenna, the GPIO pin driving the antenna must be ON.
		  '
		  ' To Retract the antenna, the GPIO pin driving the antenna must be OFF.
		  
		  
		  ' Set the antenna control GPIO pin to act as an output.
		  '
		  GPIO.PinMode(gintConfig_PinAntenna, GPIO.OUTPUT)
		  
		  ' Retract the antenna mast.
		  '
		  GPIO.DigitalWrite(gintConfig_PinAntenna, GPIO.OFF)
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Destructor()
		  
		  ' Retract the antenna mast.
		  '
		  GPIO.DigitalWrite(gintConfig_PinAntenna, GPIO.OFF)
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Extend()
		  
		  GPIO.DigitalWrite(gintConfig_PinAntenna, GPIO.ON)
		  
		  System.DebugLog("Ant:Up")
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Retract()
		  
		  GPIO.DigitalWrite(gintConfig_PinAntenna, GPIO.OFF)
		  
		  System.DebugLog("Ant:Down")
		  
		End Sub
	#tag EndMethod


	#tag ViewBehavior
		#tag ViewProperty
			Name="Index"
			Visible=true
			Group="ID"
			InitialValue="-2147483648"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Left"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Name"
			Visible=true
			Group="ID"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Super"
			Visible=true
			Group="ID"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Top"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
	#tag EndViewBehavior
End Class
#tag EndClass
