#tag Class
Protected Class audio_switch_mgr
	#tag Method, Flags = &h0
		Sub Constructor()
		  
		  ' The audio switch board accepts audio input from input #1 or input #2
		  ' based on GPIO input. Its default is audio input #1.
		  '
		  ' To select input #1, the GPIO pin driving the antenna must be OFF.
		  '
		  ' To select input #2, the GPIO pin driving the antenna must be ON.
		  
		  
		  ' Set the audio selector board's GPIO pin to act as an output.
		  '
		  GPIO.PinMode(gintConfig_PinAudioSelector, GPIO.OUTPUT)
		  
		  ' Switch the audio selector board to input #1.
		  '
		  GPIO.DigitalWrite(gintConfig_PinAudioSelector, GPIO.OFF)
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Destructor()
		  
		  ' Switch the audio selector board to input #1.
		  '
		  GPIO.DigitalWrite(gintConfig_PinAudioSelector, GPIO.OFF)
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Source(Assigns enuSource As Sources)
		  
		  ' Switch the audio selector board to the specified input.
		  '
		  Select Case enuSource
		    
		  Case audio_switch_mgr.Sources.INPUT1
		    
		    GPIO.DigitalWrite(gintConfig_PinAudioSelector, GPIO.OFF)
		    System.DebugLog("Switch:INPUT1")
		    
		  Case audio_switch_mgr.Sources.INPUT2
		    
		    GPIO.DigitalWrite(gintConfig_PinAudioSelector, GPIO.ON)
		    System.DebugLog("Switch:INPUT2")
		    
		  End Select
		  
		End Sub
	#tag EndMethod


	#tag Enum, Name = Sources, Type = Integer, Flags = &h0
		INPUT1
		INPUT2
	#tag EndEnum


	#tag ViewBehavior
		#tag ViewProperty
			Name="Index"
			Visible=true
			Group="ID"
			InitialValue="-2147483648"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Left"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Name"
			Visible=true
			Group="ID"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Super"
			Visible=true
			Group="ID"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Top"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
	#tag EndViewBehavior
End Class
#tag EndClass
