#tag Class
Protected Class music_playlist_mgr
	#tag Method, Flags = &h0
		Sub Constructor(strDatabase As String)
		  
		  Dim objFolderItem As FolderItem
		  
		  
		  ' Get folder item for database file.
		  '
		  objFolderItem = New FolderItem(strDatabase)
		  If objFolderItem = Nil Then
		    MsgBox("Error: Couldn't access database file.")
		  End If
		  
		  ' Create instance of the SQLite database object.
		  '
		  pobjDB = New SQLiteDatabase
		  
		  ' Attempt to connect database engine with the database file.
		  '
		  pobjDB.DatabaseFile = objFolderItem
		  If pobjDB.Connect = False Then
		    MsgBox("Error: " + pobjDB.ErrorMessage)
		  End If
		  
		  ' Invoke the query with no parameters to retrieve all records.
		  '
		  Query
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Destructor()
		  
		  ' Destroy instance of the SQLite recordset object.
		  '
		  pobjRS_IDs = Nil
		  
		  ' Destroy instance of the SQLite database object.
		  '
		  pobjDB = Nil
		  
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h21
		Private Sub GetMediaInfo(intID As Integer)
		  
		  Dim strSQL As String
		  
		  
		  ' Create query.
		  '
		  strSQL = "SELECT File, AlbumArt, AlbumArtist, AlbumName, TrackName FROM MusicFiles WHERE ID=" + intID.ToText
		  
		  
		  ' Execute query.
		  '
		  pobjRS_MediaInfo = pobjDB.SQLSelect(strSQL)
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function MediaArt() As Picture
		  
		  Dim p As Picture = Nil
		  
		  
		  If UBound(pintIDs) > -1 Then
		    GetMediaInfo(pintIDs(pintPtr))
		    p = pobjRS_MediaInfo.Field("AlbumArt").PictureValue
		  Else
		    p = Nil
		  End If
		  
		  Return p
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function MediaCount() As Integer
		  
		  Return UBound(pintIDs) + 1
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function MediaFile() As String
		  
		  Dim s As String
		  
		  
		  If UBound(pintIDs) > -1 Then
		    GetMediaInfo(pintIDs(pintPtr))
		    s = pobjRS_MediaInfo.Field("File").StringValue
		  Else
		    s = ""
		  End If
		  
		  Return s
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function MediaPointer() As Integer
		  
		  Return pintPtr + 1
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub MediaPointer(Assigns intValue As Integer)
		  
		  pintPtr = intValue - 1
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function MediaText() As String
		  
		  Dim s As String
		  
		  
		  If UBound(pintIDs) > -1 Then
		    GetMediaInfo(pintIDs(pintPtr))
		    s = pobjRS_MediaInfo.Field("AlbumArtist").StringValue + EndOfLine _
		    + pobjRS_MediaInfo.Field("AlbumName").StringValue + EndOfLine _
		    + pobjRS_MediaInfo.Field("TrackName").StringValue
		    
		    s = ReplaceAll(s, "&", "&&")
		  Else
		    s = ""
		  End If
		  
		  Return s
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub MoveNext()
		  
		  ' Do we have any media items to traverse?
		  ' 
		  If UBound(pintIDs) = -1 Then
		    Exit Sub
		  End If
		  
		  ' Increment pointer.
		  '
		  pintPtr = pintPtr + 1
		  
		  ' Out of bounds check.
		  '
		  If pintPtr > UBound(pintIDs) Then
		    
		    ' Is repeat flag set?
		    '
		    If pbooRepeat = True Then
		      pintPtr = 0
		    Else
		      pintPtr = UBound(pintIDs)
		    End If
		    
		  End If
		  
		  ' Get media info.
		  '
		  GetMediaInfo(pintIDs(pintPtr))
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub MovePrevious()
		  
		  ' Do we have any media items to traverse?
		  ' 
		  If UBound(pintIDs) = -1 Then
		    Exit Sub
		  End If
		  
		  ' Decrement pointer.
		  '
		  pintPtr = pintPtr - 1
		  
		  ' Out of bounds check.
		  '
		  If pintPtr < 0 Then
		    
		    ' Is repeat flag set?
		    '
		    If pbooRepeat = True Then
		      pintPtr = UBound(pintIDs)
		    Else
		      pintPtr = 0
		    End If
		    
		  End If
		  
		  ' Get media info.
		  '
		  GetMediaInfo(pintIDs(pintPtr))
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h21
		Private Sub PopulateIDArray()
		  
		  ' Purge the IDs array.
		  '
		  Redim pintIDs(-1)
		  
		  ' Move to first record.
		  '
		  pobjRS_IDs.MoveFirst
		  
		  ' Populate the IDs array.
		  '
		  Do Until pobjRS_IDs.EOF = True
		    pintIDs.Append(pobjRS_IDs.Field("ID").IntegerValue)
		    pobjRS_IDs.MoveNext
		  Loop
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Query(strSQL_Clause As String = "")
		  
		  Dim strSQL As String
		  
		  
		  ' User is issuing a new query. This means that we must execute the query,
		  ' populate the ID array, shuffle the array if needed, reset the array
		  ' pointer to zero and fetch the media info for the first array item.
		  
		  ' Define base query to gather IDs.
		  '
		  strSQL = "SELECT ID FROM MusicFiles"
		  
		  ' Execute the query with SQL clause if provided.
		  '
		  pobjRS_IDs = pobjDB.SQLSelect(strSQL + " " + strSQL_Clause)
		  
		  PopulateIDArray
		  
		  If pbooShuffle = True Then
		    pintIDs.Shuffle
		  End If
		  
		  pintPtr = 0
		  
		  If UBound(pintIDs) > -1 Then
		    GetMediaInfo(pintIDs(pintPtr))
		  End If
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function Repeat() As Boolean
		  
		  Return pbooRepeat
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Repeat(Assigns booValue As Boolean)
		  
		  ' Set repeat mode flag.
		  '
		  pbooRepeat = booValue
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function Shuffle() As Boolean
		  
		  Return pbooShuffle
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Shuffle(Assigns booValue As Boolean)
		  
		  ' Set shuffle mode flag.
		  '
		  pbooShuffle = booValue
		  
		  ' Is there anything to shuffle or unshuffle?
		  '
		  If UBound(pintIDs) = -1 Then
		    Exit Sub
		  End If
		  
		  Select Case pbooShuffle
		    
		  Case True
		    
		    ' Shuffle the IDs array.
		    '
		    pintIDs.Shuffle
		    
		    GetMediaInfo(pintIDs(pintPtr))
		    
		  Case False
		    
		    ' Unshuffle (rebuild the IDs Array).
		    '
		    PopulateIDArray
		    
		    GetMediaInfo(pintIDs(pintPtr))
		    
		  End Select
		  
		End Sub
	#tag EndMethod


	#tag Note, Name = ReadMe
		
		The MusicPlayListManager class is the interface layer between the client GUI and the underlying music files
		cataloged in the SQLite database. Playlists are defined by SQL queries. This means that a playlist will 
		autmatically include any new MP3 files that match the SQL query.
		
		All media files (MP3 music) are stored in a SQLite table named "MusicFiles". The table contains meta-data
		about each MP3 file such as:
		
		ID:
		Unique numeric ID of each MP3 file in table. When the class is instantiated, it executes a default query 
		that retrieves a recordset consisting of the ID for each file in the table and stores these IDs in an array. 
		The array is used as the playlist and can be traversed forward and backward, and each ID used to retrieve 
		the associated meta-data for a specific MP3 file. When the user turns Shuffle ON, the array is shuffled in
		which case the playlist then presents the ID's in a random order. The recordset is not discarded after it 
		is used to build the array, instead it is kept in the event that the array needs to be rebuilt such as when
		the user decides to turn Shuffle OFF and the array must then be rebuilt in the same order as the recordset.
		
		File:
		The fully qualified name of the MP3 file. This handed to the OMXPlayer to play the MP3 file.
		
		LastModified:
		The date and time the MP3 file was last modified. (A syncing routine is needed to update the MucicFiles table 
		with new or modified MP3 files and to delete records for MP3 files that are no longer in the media folder.
		When syncing the database to the MP3 folder, this date and time can be used to determine if the database
		record needs to be updated. 
		
		AlbumArt:
		A binary large object "BLOB" field that holds the artwork for the MP3 file.
		
		AlbumName:
		The name of the album that the MPS file appears on.
		
		AlbumArtist:
		The name of the artist performing on this album.
		
		AlbumYear:
		The year the album was released.
		
		Genre:
		Text describing the genre of the MP3 file.
		
		DiscNumber:
		Identifies by number a specific disc in a multi-disc album.
		
		TrackNumber:
		Identifies the order in which the MP3 file appears in its album.
		
		TrackName:
		Identifies by name the MP3 file.
		
		TrackArtist:
		The artist performing on this MP3 file. Some albums may have different artists performing on 
		each MPS file.
		
		
	#tag EndNote


	#tag Property, Flags = &h21
		Private pbooRepeat As Boolean = False
	#tag EndProperty

	#tag Property, Flags = &h21
		Private pbooShuffle As Boolean = False
	#tag EndProperty

	#tag Property, Flags = &h21
		Private pintIDs() As Integer
	#tag EndProperty

	#tag Property, Flags = &h21
		Private pintPtr As Integer = 0
	#tag EndProperty

	#tag Property, Flags = &h21
		Private pobjDB As SQLiteDatabase = Nil
	#tag EndProperty

	#tag Property, Flags = &h21
		Private pobjRS_IDs As RecordSet = Nil
	#tag EndProperty

	#tag Property, Flags = &h21
		Private pobjRS_MediaInfo As RecordSet = Nil
	#tag EndProperty


	#tag ViewBehavior
		#tag ViewProperty
			Name="Index"
			Visible=true
			Group="ID"
			InitialValue="-2147483648"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Left"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Name"
			Visible=true
			Group="ID"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Super"
			Visible=true
			Group="ID"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Top"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
	#tag EndViewBehavior
End Class
#tag EndClass
