#tag Window
Begin ContainerControl digital_clock
   AcceptFocus     =   False
   AcceptTabs      =   False
   AutoDeactivate  =   True
   BackColor       =   &c00000000
   Backdrop        =   0
   Compatibility   =   ""
   DoubleBuffer    =   False
   Enabled         =   True
   EraseBackground =   False
   HasBackColor    =   True
   Height          =   55
   HelpTag         =   ""
   InitialParent   =   ""
   Left            =   0
   LockBottom      =   False
   LockLeft        =   False
   LockRight       =   True
   LockTop         =   True
   TabIndex        =   0
   TabPanelIndex   =   0
   TabStop         =   False
   Top             =   0
   Transparent     =   False
   UseFocusRing    =   False
   Visible         =   True
   Width           =   225
   Begin Canvas cnvsDigitalClock
      AcceptFocus     =   False
      AcceptTabs      =   False
      AutoDeactivate  =   True
      Backdrop        =   0
      DoubleBuffer    =   True
      Enabled         =   True
      EraseBackground =   False
      Height          =   55
      HelpTag         =   ""
      Index           =   -2147483648
      InitialParent   =   ""
      Left            =   0
      LockBottom      =   False
      LockedInPosition=   True
      LockLeft        =   True
      LockRight       =   False
      LockTop         =   True
      Scope           =   2
      TabIndex        =   2
      TabPanelIndex   =   0
      TabStop         =   True
      Top             =   0
      Transparent     =   True
      UseFocusRing    =   False
      Visible         =   True
      Width           =   225
   End
   Begin Timer tmrDigitalClock
      Index           =   -2147483648
      LockedInPosition=   True
      Mode            =   2
      Period          =   1000
      Scope           =   2
      TabPanelIndex   =   0
   End
End
#tag EndWindow

#tag WindowCode
#tag EndWindowCode

#tag Events cnvsDigitalClock
	#tag Event
		Sub Paint(g As Graphics, areas() As REALbasic.Rect)
		  
		  Dim objDateNow As Date
		  
		  Dim intHour As Integer
		  Dim intMinute As Integer
		  Dim intSecond As Integer
		  Dim intAMPM As Integer
		  
		  Dim intHourDigit1 As Integer
		  Dim intHourDigit2 As Integer
		  Dim intColonState As Integer
		  Dim intMinuteDigit1 As Integer
		  Dim intMinuteDigit2 As Integer
		  
		  
		  ' Get snapshot of current date.
		  '
		  objDateNow = New Date
		  
		  ' Get component parts of now.
		  '
		  intHour = objDateNow.Hour
		  intMinute = objDateNow.Minute
		  intSecond = objDateNow.Second
		  
		  ' Get AM or PM and colon state.
		  '
		  intAMPM = intHour \ 12
		  intColonState = intSecond Mod 2
		  
		  ' Break hour into individual values.
		  '
		  intHourDigit1 = (intHour Mod 12) \ 10
		  intHourDigit2 = (intHour Mod 12) Mod 10
		  
		  ' Break minute into individual values.
		  '
		  intMinuteDigit1 = intMinute \ 10
		  intMinuteDigit2 = intMinute Mod 10
		  
		  ' Define character dimensions of characters in bit map.
		  '
		  Const CharWidth = 30
		  Const CharHeight = 55
		  
		  ' Define offsets for each character in bit map.
		  '
		  Const Digit_0   = CharWidth * 0
		  Const Digit_1   = CharWidth * 1
		  Const Digit_2   = CharWidth * 2
		  Const Digit_3   = CharWidth * 3
		  Const Digit_4   = CharWidth * 4
		  Const Digit_5   = CharWidth * 5
		  Const Digit_6   = CharWidth * 6
		  Const Digit_7   = CharWidth * 7
		  Const Digit_8   = CharWidth * 8
		  Const Digit_9   = CharWidth * 9
		  Const Digit_OFF = CharWidth * 10
		  Const Colon_ON  = CharWidth * 11
		  Const Colon_OFF = CharWidth * 12
		  Const AMPM_AM   = CharWidth * 13
		  Const AMPM_PM   = CharWidth * 14
		  
		  ' g.DrawPicture(Source, DestX, DestY, DestWidth, DestHeight, SourceX, SourceY, SourceWidth, SourceHeight)
		  
		  ' Draw first digit of 'hour' if non-zero.
		  '
		  If (intHourDigit1 = 0) And (intHourDigit2 = 0) Then
		    g.DrawPicture(digital_clock_palette, 0, 0, CharWidth, CharHeight, Digit_1, 0, CharWidth, CharHeight)
		  Else
		    If (intHourDigit1 = 0) Then
		      g.DrawPicture(digital_clock_palette, 0, 0, CharWidth, CharHeight, Digit_OFF, 0, CharWidth, CharHeight)
		    Else
		      g.DrawPicture(digital_clock_palette, 0, 0, CharWidth, CharHeight, CharWidth * intHourDigit1, 0, CharWidth, CharHeight)
		    End If
		  End If
		  
		  ' Draw second digit of 'hour'.
		  '
		  If (intHourDigit1 = 0) And (intHourDigit2 = 0) Then
		    g.DrawPicture(digital_clock_palette, 45, 0, CharWidth, CharHeight, Digit_2, 0, CharWidth, CharHeight)
		  Else
		    g.DrawPicture(digital_clock_palette, 45, 0, CharWidth, CharHeight, CharWidth * intHourDigit2, 0, CharWidth, CharHeight)
		  End If
		  
		  ' Draw colon either on or off.
		  ' 
		  If intColonState = 0 Then
		    g.DrawPicture(digital_clock_palette, 75, 0, CharWidth, CharHeight, Colon_OFF, 0, CharWidth, CharHeight)
		  Else
		    g.DrawPicture(digital_clock_palette, 75, 0, CharWidth, CharHeight, Colon_ON, 0, CharWidth, CharHeight)
		  End If
		  
		  ' Draw first digit of 'minute'.
		  ' 
		  g.DrawPicture(digital_clock_palette, 105, 0, CharWidth, CharHeight, CharWidth * intMinuteDigit1, 0, CharWidth, CharHeight)
		  
		  ' Draw second digit of 'minute'.
		  ' 
		  g.DrawPicture(digital_clock_palette, 150, 0, CharWidth, CharHeight, CharWidth * intMinuteDigit2, 0, CharWidth, CharHeight)
		  
		  ' Draw AM/PM indicator.
		  '
		  If intAMPM = 0 Then
		    g.DrawPicture(digital_clock_palette, 195, 0, CharWidth, CharHeight, AMPM_AM, 0, CharWidth, CharHeight)
		  Else
		    g.DrawPicture(digital_clock_palette, 195, 0, CharWidth, CharHeight, AMPM_PM, 0, CharWidth, CharHeight)
		  End If
		  
		End Sub
	#tag EndEvent
#tag EndEvents
#tag Events tmrDigitalClock
	#tag Event
		Sub Action()
		  
		  cnvsDigitalClock.Invalidate
		  
		End Sub
	#tag EndEvent
#tag EndEvents
#tag ViewBehavior
	#tag ViewProperty
		Name="DoubleBuffer"
		Visible=true
		Group="Windows Behavior"
		InitialValue="False"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="AcceptFocus"
		Visible=true
		Group="Behavior"
		InitialValue="False"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="AcceptTabs"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="AutoDeactivate"
		Visible=true
		Group="Appearance"
		InitialValue="True"
		Type="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="BackColor"
		Visible=true
		Group="Background"
		InitialValue="&hFFFFFF"
		Type="Color"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Backdrop"
		Visible=true
		Group="Background"
		Type="Picture"
		EditorType="Picture"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Enabled"
		Visible=true
		Group="Appearance"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="EraseBackground"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="HasBackColor"
		Visible=true
		Group="Background"
		InitialValue="False"
		Type="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Height"
		Visible=true
		Group="Size"
		InitialValue="300"
		Type="Integer"
	#tag EndViewProperty
	#tag ViewProperty
		Name="HelpTag"
		Visible=true
		Group="Appearance"
		Type="String"
	#tag EndViewProperty
	#tag ViewProperty
		Name="InitialParent"
		Group="Position"
		Type="String"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Left"
		Visible=true
		Group="Position"
		Type="Integer"
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockBottom"
		Visible=true
		Group="Position"
		Type="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockLeft"
		Visible=true
		Group="Position"
		Type="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockRight"
		Visible=true
		Group="Position"
		Type="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockTop"
		Visible=true
		Group="Position"
		Type="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Name"
		Visible=true
		Group="ID"
		Type="String"
		EditorType="String"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Super"
		Visible=true
		Group="ID"
		Type="String"
		EditorType="String"
	#tag EndViewProperty
	#tag ViewProperty
		Name="TabIndex"
		Visible=true
		Group="Position"
		InitialValue="0"
		Type="Integer"
	#tag EndViewProperty
	#tag ViewProperty
		Name="TabPanelIndex"
		Group="Position"
		InitialValue="0"
		Type="Integer"
	#tag EndViewProperty
	#tag ViewProperty
		Name="TabStop"
		Visible=true
		Group="Position"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Top"
		Visible=true
		Group="Position"
		Type="Integer"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Transparent"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="UseFocusRing"
		Visible=true
		Group="Appearance"
		InitialValue="False"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Visible"
		Visible=true
		Group="Appearance"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Width"
		Visible=true
		Group="Size"
		InitialValue="300"
		Type="Integer"
	#tag EndViewProperty
#tag EndViewBehavior
