#tag Window
Begin ContainerControl obd_viewer_gui
   AcceptFocus     =   False
   AcceptTabs      =   True
   AutoDeactivate  =   True
   BackColor       =   &cFFFFFF00
   Backdrop        =   1106249727
   Compatibility   =   ""
   DoubleBuffer    =   False
   Enabled         =   True
   EraseBackground =   True
   HasBackColor    =   False
   Height          =   360
   HelpTag         =   ""
   InitialParent   =   ""
   Left            =   0
   LockBottom      =   False
   LockLeft        =   False
   LockRight       =   False
   LockTop         =   False
   TabIndex        =   0
   TabPanelIndex   =   0
   TabStop         =   True
   Top             =   0
   Transparent     =   True
   UseFocusRing    =   False
   Visible         =   True
   Width           =   510
   Begin Rectangle rctnglBackdrop
      AutoDeactivate  =   True
      BorderWidth     =   1
      BottomRightColor=   &c00000000
      Enabled         =   True
      FillColor       =   &c00000000
      Height          =   273
      HelpTag         =   ""
      Index           =   -2147483648
      InitialParent   =   ""
      Left            =   0
      LockBottom      =   True
      LockedInPosition=   True
      LockLeft        =   True
      LockRight       =   True
      LockTop         =   True
      Scope           =   2
      TabIndex        =   0
      TabPanelIndex   =   0
      TabStop         =   True
      Top             =   0
      TopLeftColor    =   &c00000000
      Transparent     =   True
      Visible         =   True
      Width           =   510
      Begin Label lblALDL_Data
         AutoDeactivate  =   True
         Bold            =   False
         DataField       =   ""
         DataSource      =   ""
         Enabled         =   True
         Height          =   233
         HelpTag         =   ""
         Index           =   -2147483648
         InitialParent   =   "rctnglBackdrop"
         Italic          =   False
         Left            =   20
         LockBottom      =   False
         LockedInPosition=   True
         LockLeft        =   True
         LockRight       =   False
         LockTop         =   True
         Multiline       =   True
         Scope           =   2
         Selectable      =   False
         TabIndex        =   0
         TabPanelIndex   =   0
         TabStop         =   True
         Text            =   ""
         TextAlign       =   0
         TextColor       =   &cFCE11800
         TextFont        =   "Courier"
         TextSize        =   16.0
         TextUnit        =   1
         Top             =   20
         Transparent     =   True
         Underline       =   False
         Visible         =   True
         Width           =   470
      End
   End
   Begin super_bevel_button sbbtnPower
      AcceptFocus     =   True
      AutoDeactivate  =   True
      BackColor       =   &cC0C0C000
      Bevel           =   0
      Bold            =   False
      ButtonType      =   0
      Caption         =   ""
      CaptionAlign    =   3
      CaptionDelta    =   0
      CaptionPlacement=   1
      Enabled         =   True
      HasBackColor    =   False
      HasMenu         =   0
      Height          =   75
      HelpTag         =   ""
      Icon            =   1166247935
      IconAlign       =   1
      IconDX          =   0
      IconDY          =   0
      Index           =   -2147483648
      InitialParent   =   ""
      Italic          =   False
      Left            =   0
      LockBottom      =   False
      LockedInPosition=   True
      LockLeft        =   True
      LockRight       =   False
      LockTop         =   True
      MenuValue       =   0
      Scope           =   2
      TabIndex        =   1
      TabPanelIndex   =   0
      TabStop         =   True
      TextColor       =   &c00000000
      TextFont        =   "System"
      TextSize        =   0.0
      TextUnit        =   0
      Top             =   285
      Transparent     =   False
      Underline       =   False
      Value           =   False
      Visible         =   True
      Width           =   142
   End
End
#tag EndWindow

#tag WindowCode
	#tag Event
		Sub Close()
		  
		  pobjSerial.Close
		  
		  pstrBuffer = ""
		  
		End Sub
	#tag EndEvent

	#tag Event
		Sub Open()
		  
		End Sub
	#tag EndEvent


	#tag Method, Flags = &h0
		Sub Constructor()
		  
		  ' Create serial communications object
		  '
		  pobjSerial = New Serial
		  
		  AddHandler pobjSerial.DataAvailable,AddressOf Serial_DataAvailable_Handler
		  AddHandler pobjSerial.Error,AddressOf Serial_Error_Handler
		  
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Destructor()
		  
		  ' Destroy serial comm object
		  '
		  pobjSerial = Nil 
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h21
		Private Sub Serial_DataAvailable_Handler(s As Serial)
		  
		  Dim strALDL_Data As String
		  Dim intCRLF_Position As Integer
		  
		  ' Retreive any waiting data.
		  ' 
		  pstrBuffer = pstrBuffer + s.ReadAll(Encodings.ASCII)
		  
		  ' Get position of carriage return + line feed (end of message marker).
		  '
		  intCRLF_Position = InStrB(pstrBuffer, Chr(13) + Chr(10))
		  
		  ' Was end of message marker found?
		  ' 
		  If intCRLF_Position = 0 Then Exit Sub
		  
		  ' Copy ALDL message.
		  '
		  strALDL_Data = Trim(LeftB(pstrBuffer, intCRLF_Position + 1))
		  
		  ' Delete ALDL message from buffer.
		  '
		  pstrBuffer = MidB(pstrBuffer, intCRLF_Position + 1)
		  
		  ' Check for beginning and end of message markers.
		  '
		  If (LeftB(strALDL_Data, 9) <> "111111111") Then
		    Exit Sub
		  End If
		  
		  ' Display ALDL bit string.
		  ' 
		  lblALDL_Data.Text = strALDL_Data
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h21
		Private Sub Serial_Error_Handler(s As Serial)
		  
		  AckBox "Serial Error", "A serial port error occurred. (" + s.LastErrorCode.ToText + ")"
		  
		End Sub
	#tag EndMethod


	#tag Property, Flags = &h21
		Private penuPowerState As PowerStates = PowerStates.OFF
	#tag EndProperty

	#tag Property, Flags = &h21
		Private pobjSerial As Serial = Nil
	#tag EndProperty

	#tag Property, Flags = &h21
		Private pstrBuffer As String
	#tag EndProperty


	#tag Enum, Name = PowerStates, Flags = &h0
		OFF
		ON
	#tag EndEnum


#tag EndWindowCode

#tag Events lblALDL_Data
	#tag Event
		Function MouseDown(X As Integer, Y As Integer) As Boolean
		  
		  lblALDL_Data.Text = ""
		  
		End Function
	#tag EndEvent
#tag EndEvents
#tag Events sbbtnPower
	#tag Event
		Function MouseDown(X As Integer, Y As Integer) As Boolean
		  
		  ' Hilite button icon.
		  '
		  Me.Icon = New Picture(icon_power_red_32.Width, icon_power_red_32.Height)
		  Me.Icon.Graphics.DrawPicture(icon_power_red_32, 0, 0)
		  Me.Refresh
		  
		  Return True
		  
		End Function
	#tag EndEvent
	#tag Event
		Function MouseUp(X As Integer, Y As Integer) As Boolean
		  
		  Select Case penuPowerState
		    
		  Case PowerStates.OFF
		    
		    ' Hilite button icon.
		    '
		    Me.Icon = New Picture(icon_power_red_32.Width, icon_power_red_32.Height)
		    Me.Icon.Graphics.DrawPicture(icon_power_red_32, 0, 0)
		    Me.Refresh
		    
		    penuPowerState = PowerStates.ON
		    
		    pstrBuffer = ""
		    
		    pobjSerial.SerialPort = System.SerialPort(gstrConfig_OBD_Device)
		    pobjSerial.Baud       = Serial.Baud115200
		    pobjSerial.Bits       = Serial.Bits8
		    pobjSerial.Parity     = Serial.ParityNone
		    pobjSerial.Stop       = Serial.StopBits1
		    pobjSerial.XON        = False
		    pobjSerial.CTS        = False
		    pobjSerial.DTR        = False
		    
		    If pobjSerial.Open = False Then
		      AckBox "Serial Open", "Serial port failed to open."
		    End If
		    
		  Case PowerStates.ON
		    
		    ' Lolite button icon.
		    '
		    Me.Icon = New Picture(icon_power_black_32.Width, icon_power_black_32.Height)
		    Me.Icon.Graphics.DrawPicture(icon_power_black_32, 0, 0)
		    Me.Refresh
		    
		    penuPowerState = PowerStates.OFF
		    
		    pobjSerial.Close
		    
		    pstrBuffer = ""
		    
		  End Select
		  
		End Function
	#tag EndEvent
	#tag Event
		Sub Open()
		  
		  ' Set icon property.
		  '
		  Me.Icon = New Picture(icon_power_black_32.Width, icon_power_black_32.Height)
		  Me.Icon.Graphics.DrawPicture(icon_power_black_32, 0, 0)
		  
		End Sub
	#tag EndEvent
#tag EndEvents
#tag ViewBehavior
	#tag ViewProperty
		Name="DoubleBuffer"
		Visible=true
		Group="Windows Behavior"
		InitialValue="False"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="AcceptFocus"
		Visible=true
		Group="Behavior"
		InitialValue="False"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="AcceptTabs"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="AutoDeactivate"
		Visible=true
		Group="Appearance"
		InitialValue="True"
		Type="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="BackColor"
		Visible=true
		Group="Background"
		InitialValue="&hFFFFFF"
		Type="Color"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Backdrop"
		Visible=true
		Group="Background"
		Type="Picture"
		EditorType="Picture"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Enabled"
		Visible=true
		Group="Appearance"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="EraseBackground"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="HasBackColor"
		Visible=true
		Group="Background"
		InitialValue="False"
		Type="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Height"
		Visible=true
		Group="Size"
		InitialValue="300"
		Type="Integer"
	#tag EndViewProperty
	#tag ViewProperty
		Name="HelpTag"
		Visible=true
		Group="Appearance"
		Type="String"
	#tag EndViewProperty
	#tag ViewProperty
		Name="InitialParent"
		Group="Position"
		Type="String"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Left"
		Visible=true
		Group="Position"
		Type="Integer"
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockBottom"
		Visible=true
		Group="Position"
		Type="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockLeft"
		Visible=true
		Group="Position"
		Type="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockRight"
		Visible=true
		Group="Position"
		Type="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockTop"
		Visible=true
		Group="Position"
		Type="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Name"
		Visible=true
		Group="ID"
		Type="String"
		EditorType="String"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Super"
		Visible=true
		Group="ID"
		Type="String"
		EditorType="String"
	#tag EndViewProperty
	#tag ViewProperty
		Name="TabIndex"
		Visible=true
		Group="Position"
		InitialValue="0"
		Type="Integer"
	#tag EndViewProperty
	#tag ViewProperty
		Name="TabPanelIndex"
		Group="Position"
		InitialValue="0"
		Type="Integer"
	#tag EndViewProperty
	#tag ViewProperty
		Name="TabStop"
		Visible=true
		Group="Position"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Top"
		Visible=true
		Group="Position"
		Type="Integer"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Transparent"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="UseFocusRing"
		Visible=true
		Group="Appearance"
		InitialValue="False"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Visible"
		Group="Behavior"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Width"
		Visible=true
		Group="Size"
		InitialValue="300"
		Type="Integer"
	#tag EndViewProperty
#tag EndViewBehavior
