#tag Module
Protected Module common
	#tag Method, Flags = &h0
		Sub AckBox(strTitle As String, strMessage As String, booWarning As Boolean = False)
		  
		  Dim objAckBox As New ack_box
		  
		  objAckBox.PopUp strTitle, strMessage, booWarning
		  
		  objAckBox = Nil
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function AskBox(strTitle As String, strMessage As String) As ask_box.CloseMethods
		  
		  Dim enuCloseMethod As ask_box.CloseMethods
		  Dim objAskBox As ask_box
		  
		  
		  objAskBox = New ask_box
		  
		  enuCloseMethod = objAskBox.PopUp(strTitle, strMessage)
		  
		  objAskBox = Nil
		  
		  Return enuCloseMethod
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Chirp(intChirps As Integer = 1)
		  
		  Dim i As Integer
		  
		  
		  ' Chirp the piezo.
		  '
		  For i = 1 To intChirps
		    GPIO.DigitalWrite(gintConfig_PinBeeper, GPIO.ON)
		    GPIO.Delay(25)
		    GPIO.DigitalWrite(gintConfig_PinBeeper, GPIO.OFF)
		    GPIO.Delay(25)
		  Next i
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub ConfigLoad()
		  
		  Dim objINI As INI
		  
		  ' Create INI object
		  '
		  objINI = New INI(gobjINI_File)
		  
		  ' Load configuration
		  '
		  objINI.Load
		  
		  ' GUI Colors
		  '
		  gclrConfig_DashboardDarkGray  = objINI.Get("Colors", "dashboard_dark_gray", &c202020)
		  gclrConfig_DashboardGreen     = objINI.Get("Colors", "dashboard_green",     &c00FF00)
		  gclrConfig_DashboardRed       = objINI.Get("Colors", "dashboard_Red",       &cFF0000)
		  gclrConfig_DashboardYellow    = objINI.Get("Colors", "dashboard_yellow",    &cFFFF00)
		  
		  ' FM Radio 
		  '
		  gstrConfig_RadioPreset1 = objINI.Get("Radio", "Preset_1", "")
		  gstrConfig_RadioPreset2 = objINI.Get("Radio", "Preset_2", "")
		  gstrConfig_RadioPreset3 = objINI.Get("Radio", "Preset_3", "")
		  gstrConfig_RadioPreset4 = objINI.Get("Radio", "Preset_4", "")
		  
		  ' Music Player
		  '
		  gstrConfig_MusicDefaultQueryFile = objINI.Get("Music", "default_query_file", "(Everything)")
		  
		  ' Movie Player
		  '
		  gstrConfig_MovieDefaultQueryFile = objINI.Get("Movie", "default_query_file", "(Everything)")
		  gstrConfig_MovieAspectMode       = objINI.Get("Movie", "aspect_mode",        "letterbox"   )
		  
		  ' GPS Recorder
		  '
		  gstrConfig_GPS_Device = objINI.Get("GPS", "Device", "")
		  gstrConfig_GPS_Logs   = objINI.Get("GPS", "Logs",   "")
		  
		  ' Diagnostics
		  '
		  gstrConfig_OBD_Device = objINI.Get("OBD", "Device", "")
		  
		  ' GPIO
		  '
		  gintConfig_PinAmplifier     = objINI.Get("GPIO", "pin_amplifier",      17)
		  gintConfig_PinAntenna       = objINI.Get("GPIO", "pin_antenna",        18)
		  gintConfig_PinAudioSelector = objINI.Get("GPIO", "pin_audio_selector", 12)
		  gintConfig_PinBeeper        = objINI.Get("GPIO", "pin_beeper",         26)
		  
		  ' Destroy INI object
		  '
		  objINI = Nil
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub ConfigSave()
		  
		  Dim objINI As INI
		  
		  ' Create INI object
		  '
		  objINI = New INI(gobjINI_File)
		  
		  ' GUI Colors
		  '
		  objINI.Put("Colors", "DashboardDarkGray",  gclrConfig_DashboardDarkGray)
		  objINI.Put("Colors", "DashboardGreen",     gclrConfig_DashboardGreen)
		  objINI.Put("Colors", "DashboardRed",       gclrConfig_DashboardRed)
		  objINI.Put("Colors", "DashboardYellow",    gclrConfig_DashboardYellow)
		  
		  ' FM Radio 
		  '
		  objINI.Put("Radio", "Preset1", gstrConfig_RadioPreset1)
		  objINI.Put("Radio", "Preset2", gstrConfig_RadioPreset2)
		  objINI.Put("Radio", "Preset3", gstrConfig_RadioPreset3)
		  objINI.Put("Radio", "Preset4", gstrConfig_RadioPreset4)
		  
		  ' Music Player
		  '
		  objINI.Put("Music", "DefaultQueryFile", gstrConfig_MusicDefaultQueryFile)
		  
		  ' Movie Player
		  '
		  objINI.Put("Movie", "DefaultQueryFile", gstrConfig_MovieDefaultQueryFile)
		  objINI.Put("Movie", "AspectMode",       gstrConfig_MovieAspectMode)
		  
		  ' GPS Recorder
		  '
		  objINI.Put("GPS", "Device", gstrConfig_GPS_Device)
		  objINI.Put("GPS", "Logs",   gstrConfig_GPS_Logs)
		  
		  ' Diagnostics
		  '
		  objINI.Put("OBD", "Device", gstrConfig_OBD_Device)
		  
		  ' GPIO
		  '
		  objINI.Put("GPIO", "PinAmplifier",     gintConfig_PinAmplifier)
		  objINI.Put("GPIO", "PinAntenna",       gintConfig_PinAntenna)
		  objINI.Put("GPIO", "PinAudioSelector", gintConfig_PinAudioSelector)
		  objINI.Put("GPIO", "PinBeeper",        gintConfig_PinBeeper)
		  
		  ' Save configuration
		  '
		  objINI.Save
		  
		  ' Destroy INI object
		  '
		  objINI = Nil
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function DblQuote(s As String) As String
		  
		  ' Returns the supplied string wrapped in double-quotes.
		  '
		  Return Chr(34) + s + Chr(34)
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function FileExists(strFile As String) As Boolean
		  
		  Dim objFolderItem As FolderItem
		  
		  
		  objFolderItem = GetFolderItem(strFile, FolderItem.PathTypeNative)
		  If (objFolderItem <> Nil) And (objFolderItem.Exists = True) And (objFolderItem.Directory = False) Then
		    Return True
		  Else
		    Return False
		  End If
		  
		  
		  Exception Error As RunTimeException
		    AckBox "Error in: " + CurrentMethodName, "Error Number: " + Error.ErrorNumber.ToText + EndOfLine + "Error Message: " + LinuxSysErrorLookup(Error.ErrorNumber) + EndOfLine + EndOfLine + "Application will close.", True
		    Quit
		    
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function FileToString(strFilename As String) As String
		  
		  Dim objFolderItem As FolderItem
		  Dim objBinaryStream As BinaryStream
		  Dim strData As String
		  
		  
		  ' Load data from file into string.
		  '
		  objFolderItem = GetFolderItem(strFilename, FolderItem.PathTypeNative)
		  objBinaryStream = BinaryStream.Open(objFolderItem)
		  strData = objBinaryStream.Read(objBinaryStream.Length, Encodings.ASCII)
		  objBinaryStream.Close
		  
		  Return strData
		  
		  
		  Exception Error As RunTimeException
		    AckBox "Error in: " + CurrentMethodName, "Error Number: " + Error.ErrorNumber.ToText + EndOfLine + "Error Message: " + LinuxSysErrorLookup(Error.ErrorNumber) + EndOfLine + EndOfLine + "Application will close.", True
		    Quit
		    
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function LinuxSysErrorLookup(intErrNum As Integer) As String
		  
		  Dim strSysErrors(133) As String
		  
		  strSysErrors(001) = "Operation not permitted"
		  strSysErrors(002) = "No such file or directory"
		  strSysErrors(003) = "No such process"
		  strSysErrors(004) = "Interrupted system call"
		  strSysErrors(005) = "Input/output error"
		  strSysErrors(006) = "No such device or address"
		  strSysErrors(007) = "Argument list too long"
		  strSysErrors(008) = "Exec format error"
		  strSysErrors(009) = "Bad file descriptor"
		  strSysErrors(010) = "No child processes"
		  strSysErrors(011) = "Resource temporarily unavailable"
		  strSysErrors(012) = "Cannot allocate memory"
		  strSysErrors(013) = "Permission denied"
		  strSysErrors(014) = "Bad address"
		  strSysErrors(015) = "Block device required"
		  strSysErrors(016) = "Device or resource busy"
		  strSysErrors(017) = "File exists"
		  strSysErrors(018) = "Invalid cross-device link"
		  strSysErrors(019) = "No such device"
		  strSysErrors(020) = "Not a directory"
		  strSysErrors(021) = "Is a directory"
		  strSysErrors(022) = "Invalid argument"
		  strSysErrors(023) = "File table overflow"
		  strSysErrors(024) = "Too many open files"
		  strSysErrors(025) = "Inappropriate ioctl for device"
		  strSysErrors(026) = "Text file busy"
		  strSysErrors(027) = "File too large"
		  strSysErrors(028) = "No space left on device"
		  strSysErrors(029) = "Illegal seek"
		  strSysErrors(030) = "Read-only file system"
		  strSysErrors(031) = "Too many links"
		  strSysErrors(032) = "Broken pipe"
		  strSysErrors(033) = "Numerical argument out of domain"
		  strSysErrors(034) = "Numerical result out of range"
		  strSysErrors(035) = "Resource deadlock avoided"
		  strSysErrors(036) = "File name too long"
		  strSysErrors(037) = "No record locks available"
		  strSysErrors(038) = "Function not implemented"
		  strSysErrors(039) = "Directory not empty"
		  strSysErrors(040) = "Too many levels of symbolic links"
		  strSysErrors(041) = "?"
		  strSysErrors(042) = "No message of desired type"
		  strSysErrors(043) = "Identifier removed"
		  strSysErrors(044) = "Channel number out of range"
		  strSysErrors(045) = "Level 2 not synchronized"
		  strSysErrors(046) = "Level 3 halted"
		  strSysErrors(047) = "Level 3 reset"
		  strSysErrors(048) = "Link number out of range"
		  strSysErrors(049) = "Protocol driver not attached"
		  strSysErrors(050) = "No CSI structure available"
		  strSysErrors(051) = "Level 2 halted"
		  strSysErrors(052) = "Invalid exchange"
		  strSysErrors(053) = "Invalid request descriptor"
		  strSysErrors(054) = "Exchange full"
		  strSysErrors(055) = "No anode"
		  strSysErrors(056) = "Invalid request code"
		  strSysErrors(057) = "Invalid slot"
		  strSysErrors(058) = "?"
		  strSysErrors(059) = "Bad font file format"
		  strSysErrors(060) = "Device not a stream"
		  strSysErrors(061) = "No data available"
		  strSysErrors(062) = "Timer expired"
		  strSysErrors(063) = "Out of streams resources"
		  strSysErrors(064) = "Machine is not on the network"
		  strSysErrors(065) = "Package not installed"
		  strSysErrors(066) = "Object is remote"
		  strSysErrors(067) = "Link has been severed"
		  strSysErrors(068) = "Advertise error"
		  strSysErrors(069) = "Srmount error"
		  strSysErrors(070) = "Communication error on send"
		  strSysErrors(071) = "Protocol error"
		  strSysErrors(072) = "Multihop attempted"
		  strSysErrors(073) = "RFS specific error"
		  strSysErrors(074) = "Bad message"
		  strSysErrors(075) = "Value too large for defined data type"
		  strSysErrors(076) = "Name not unique on network"
		  strSysErrors(077) = "File descriptor in bad state"
		  strSysErrors(078) = "Remote address changed"
		  strSysErrors(079) = "Can not access a needed shared library"
		  strSysErrors(080) = "Accessing a corrupted shared library"
		  strSysErrors(081) = ".lib section in a.out corrupted"
		  strSysErrors(082) = "Attempting to link in too many shared libraries"
		  strSysErrors(083) = "Cannot exec a shared library directly"
		  strSysErrors(084) = "Invalid or incomplete multibyte or wide character"
		  strSysErrors(085) = "Interrupted system call should be restarted"
		  strSysErrors(086) = "Streams pipe error"
		  strSysErrors(087) = "Too many users"
		  strSysErrors(088) = "Socket operation on non-socket"
		  strSysErrors(089) = "Destination address required"
		  strSysErrors(090) = "Message too long"
		  strSysErrors(091) = "Protocol wrong type for socket"
		  strSysErrors(092) = "Protocol not available"
		  strSysErrors(093) = "Protocol not supported"
		  strSysErrors(094) = "Socket type not supported"
		  strSysErrors(095) = "Operation not supported"
		  strSysErrors(096) = "Protocol family not supported"
		  strSysErrors(097) = "Address family not supported by protocol"
		  strSysErrors(098) = "Address already in use"
		  strSysErrors(099) = "Cannot assign requested address"
		  strSysErrors(100) = "Network is down"
		  strSysErrors(101) = "ENETUNREACH Network is unreachable"
		  strSysErrors(102) = "Network dropped connection on reset"
		  strSysErrors(103) = "Software caused connection abort"
		  strSysErrors(104) = "Connection reset by peer"
		  strSysErrors(105) = "No buffer space available"
		  strSysErrors(106) = "Transport endpoint is already connected"
		  strSysErrors(107) = "Transport endpoint is not connected"
		  strSysErrors(108) = "Cannot send after transport endpoint shutdown"
		  strSysErrors(109) = "Too many references: cannot splice"
		  strSysErrors(110) = "Connection timed out"
		  strSysErrors(111) = "Connection refused"
		  strSysErrors(112) = "Host is down"
		  strSysErrors(113) = "No route to host"
		  strSysErrors(114) = "Operation already in progress"
		  strSysErrors(115) = "Operation now in progress"
		  strSysErrors(116) = "Stale file handle"
		  strSysErrors(117) = "Structure needs cleaning"
		  strSysErrors(118) = "Not a XENIX named type file"
		  strSysErrors(119) = "No XENIX semaphores available"
		  strSysErrors(120) = "Is a named type file"
		  strSysErrors(121) = "Remote I/O error"
		  strSysErrors(122) = "Disk quota exceeded"
		  strSysErrors(123) = "No medium found"
		  strSysErrors(124) = "Wrong medium type"
		  strSysErrors(125) = "Operation canceled"
		  strSysErrors(126) = "Required key not available"
		  strSysErrors(127) = "Key has expired"
		  strSysErrors(128) = "Key has been revoked"
		  strSysErrors(129) = "Key was rejected by service"
		  strSysErrors(130) = "Owner died"
		  strSysErrors(131) = "State not recoverable"
		  strSysErrors(132) = "Operation not possible due to RF-kill"
		  strSysErrors(133) = "Memory page has hardware error"
		  
		  If (intErrNum >= 0) And (intErrNum <= strSysErrors.Ubound) Then
		    Return  strSysErrors(intErrNum)
		  Else
		    Return "Error lookup failed."
		  End If
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub ReColor(pic As Picture, clrSearch As Color, clrReplace As Color)
		  
		  Dim objRGBSurface As RGBSurface = pic.RGBSurface
		  Dim intLastX As Integer = pic.Width -1
		  Dim intLastY As Integer = pic.Height -1
		  
		  ' Scan the picture and perfrom a color search and replace.
		  '
		  For Y  As Integer = 0 To intLastY
		    For X As integer = 0 To intLastX
		      If objRGBSurface.Pixel(X,Y) = clrSearch  Then
		        objRGBSurface.Pixel(X,Y) = clrReplace
		      End if
		    Next
		  Next
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function Repeat(s As String, n As Integer) As String
		  
		  Dim strTemp As String
		  
		  If n <= 0 Then Return ""
		  If n  = 1 Then Return s
		  
		  strTemp = ""
		  For Index As Integer = 1 To n
		    strTemp = strTemp + s
		  Next Index
		  
		  Return strTemp
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function SglQuote(s As String) As String
		  ' Returns the supplied string wrapped in single-quotes.
		  '
		  Return Chr(39) + s + Chr(39)
		  
		End Function
	#tag EndMethod


	#tag Property, Flags = &h0
		gclrConfig_DashboardDarkGray As Color
	#tag EndProperty

	#tag Property, Flags = &h0
		gclrConfig_DashboardGreen As Color
	#tag EndProperty

	#tag Property, Flags = &h0
		gclrConfig_DashboardRed As Color
	#tag EndProperty

	#tag Property, Flags = &h0
		gclrConfig_DashboardYellow As Color
	#tag EndProperty

	#tag Property, Flags = &h0
		gintConfig_PinAmplifier As Integer
	#tag EndProperty

	#tag Property, Flags = &h0
		gintConfig_PinAntenna As Integer
	#tag EndProperty

	#tag Property, Flags = &h0
		gintConfig_PinAudioSelector As Integer
	#tag EndProperty

	#tag Property, Flags = &h0
		gintConfig_PinBeeper As Integer
	#tag EndProperty

	#tag Property, Flags = &h0
		gobjAmplifierMgr As amplifier_mgr = Nil
	#tag EndProperty

	#tag Property, Flags = &h0
		gobjAntennaMgr As antenna_mgr = Nil
	#tag EndProperty

	#tag Property, Flags = &h0
		gobjAudioSwitchMgr As audio_switch_mgr = Nil
	#tag EndProperty

	#tag Property, Flags = &h0
		gobjINI_File As FolderItem = Nil
	#tag EndProperty

	#tag Property, Flags = &h0
		gobjMainWindow As main_window = Nil
	#tag EndProperty

	#tag Property, Flags = &h0
		gstrAppName As String
	#tag EndProperty

	#tag Property, Flags = &h0
		gstrAppPath As String
	#tag EndProperty

	#tag Property, Flags = &h0
		gstrConfig_GPS_Device As String
	#tag EndProperty

	#tag Property, Flags = &h0
		gstrConfig_GPS_Logs As String
	#tag EndProperty

	#tag Property, Flags = &h0
		gstrConfig_MovieAspectMode As String
	#tag EndProperty

	#tag Property, Flags = &h0
		gstrConfig_MovieDefaultQueryFile As String
	#tag EndProperty

	#tag Property, Flags = &h0
		gstrConfig_MusicDefaultQueryFile As String
	#tag EndProperty

	#tag Property, Flags = &h0
		gstrConfig_OBD_Device As String
	#tag EndProperty

	#tag Property, Flags = &h0
		gstrConfig_RadioPreset1 As String
	#tag EndProperty

	#tag Property, Flags = &h0
		gstrConfig_RadioPreset2 As String
	#tag EndProperty

	#tag Property, Flags = &h0
		gstrConfig_RadioPreset3 As String
	#tag EndProperty

	#tag Property, Flags = &h0
		gstrConfig_RadioPreset4 As String
	#tag EndProperty


	#tag ViewBehavior
		#tag ViewProperty
			Name="gstrAppName"
			Group="Behavior"
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gstrAppPath"
			Group="Behavior"
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gclrConfig_DashboardDarkGray"
			Group="Behavior"
			InitialValue="&c000000"
			Type="Color"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gclrConfig_DashboardGreen"
			Group="Behavior"
			InitialValue="&c000000"
			Type="Color"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gclrConfig_DashboardRed"
			Group="Behavior"
			InitialValue="&c000000"
			Type="Color"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gclrConfig_DashboardYellow"
			Group="Behavior"
			InitialValue="&c000000"
			Type="Color"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gstrConfig_GPS_Device"
			Group="Behavior"
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gstrConfig_GPS_Logs"
			Group="Behavior"
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gstrConfig_MovieAspectMode"
			Group="Behavior"
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gstrConfig_MovieDefaultQueryFile"
			Group="Behavior"
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gstrConfig_MusicDefaultQueryFile"
			Group="Behavior"
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gstrConfig_OBD_Device"
			Group="Behavior"
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gintConfig_PinAmplifier"
			Group="Behavior"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gintConfig_PinAntenna"
			Group="Behavior"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gintConfig_PinAudioSelector"
			Group="Behavior"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gintConfig_PinBeeper"
			Group="Behavior"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gstrConfig_RadioPreset1"
			Group="Behavior"
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gstrConfig_RadioPreset2"
			Group="Behavior"
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gstrConfig_RadioPreset3"
			Group="Behavior"
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gstrConfig_RadioPreset4"
			Group="Behavior"
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Index"
			Visible=true
			Group="ID"
			InitialValue="-2147483648"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Left"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Name"
			Visible=true
			Group="ID"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Super"
			Visible=true
			Group="ID"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Top"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
	#tag EndViewBehavior
End Module
#tag EndModule
