#tag Window
Begin Window full_screen_movie_backdrop
   BackColor       =   &c00000000
   Backdrop        =   0
   CloseButton     =   True
   Compatibility   =   ""
   Composite       =   False
   Frame           =   4
   FullScreen      =   False
   FullScreenButton=   False
   HasBackColor    =   True
   Height          =   480
   ImplicitInstance=   False
   LiveResize      =   True
   MacProcID       =   0
   MaxHeight       =   480
   MaximizeButton  =   True
   MaxWidth        =   800
   MenuBar         =   0
   MenuBarVisible  =   True
   MinHeight       =   64
   MinimizeButton  =   True
   MinWidth        =   64
   Placement       =   0
   Resizeable      =   True
   Title           =   ""
   Visible         =   False
   Width           =   800
End
#tag EndWindow

#tag WindowCode
	#tag Event
		Sub Activate()
		  
		  ' Move the mouse pointer to make it go invisible.
		  '
		  Dim objShell As Shell = New Shell
		  objShell.Execute("point-rpi")
		  objShell = Nil
		  
		  ' Now that the backdrop window is activated, activate the Movie player's
		  ' full-screen mode.
		  '
		  If pobjMoviePlayerMgr.FullScreen = False Then
		    pobjMoviePlayerMgr.FullScreen = True
		  End If
		  
		End Sub
	#tag EndEvent

	#tag Event
		Sub Close()
		  
		  ' Now that the backdrop window is closed, deactivate the Movie player's 
		  ' full-screen mode.
		  '
		  pobjMoviePlayerMgr.FullScreen = False
		  
		End Sub
	#tag EndEvent

	#tag Event
		Function MouseDown(X As Integer, Y As Integer) As Boolean
		  
		  If (X >= 0) And (X <= (Me.Width * .33)) Then
		    
		    ' User poked somewhere in the left 1/3 of the Movie display so seek backward 5 minutes.
		    '
		    If pobjMoviePlayerMgr.State = movie_player_mgr.States.Playing Then
		      Chirp
		      pobjMoviePlayerMgr.Seek(-5)
		    End If
		    
		  Elseif (X > (Me.Width * .33)) And (X < (Me.Width * .66)) Then
		    
		    ' User poked somewhere In the middle 1/3 of the Movie display so close the full-screen
		    ' backdrop window.
		    '
		    Chirp
		    Self.Close
		    
		  Elseif (X >= (Me.Width * .66)) And (X <= Me.Width) Then
		    
		    ' User poked somewhere in the right 1/3 of the Movie display so seek forward 5 minutes.
		    '
		    If pobjMoviePlayerMgr.State = movie_player_mgr.States.Playing Then
		      Chirp
		      pobjMoviePlayerMgr.Seek(5)
		    End If
		    
		  End If
		  
		  Return True
		  
		End Function
	#tag EndEvent

	#tag Event
		Sub Open()
		  
		  ' Move the mouse pointer to make it go invisible.
		  '
		  Dim objShell As Shell = New Shell
		  objShell.Execute("point-rpi")
		  objShell = Nil
		  
		  ' Configure window.
		  '
		  Self.FullScreen = True
		  Self.SetFocus
		  
		End Sub
	#tag EndEvent


	#tag Method, Flags = &h0
		Sub PopUp(objMoviePlayerMgr As movie_player_mgr)
		  
		  ' Receive reference to existing Movie player object.
		  '
		  pobjMoviePlayerMgr = objMoviePlayerMgr
		  
		  
		  Self.ShowModal
		  
		End Sub
	#tag EndMethod


	#tag Property, Flags = &h21
		Private pobjMoviePlayerMgr As movie_player_mgr = Nil
	#tag EndProperty


#tag EndWindowCode

#tag ViewBehavior
	#tag ViewProperty
		Name="BackColor"
		Visible=true
		Group="Background"
		InitialValue="&hFFFFFF"
		Type="Color"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Backdrop"
		Visible=true
		Group="Background"
		Type="Picture"
		EditorType="Picture"
	#tag EndViewProperty
	#tag ViewProperty
		Name="CloseButton"
		Visible=true
		Group="Frame"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Composite"
		Group="OS X (Carbon)"
		InitialValue="False"
		Type="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Frame"
		Visible=true
		Group="Frame"
		InitialValue="0"
		Type="Integer"
		EditorType="Enum"
		#tag EnumValues
			"0 - Document"
			"1 - Movable Modal"
			"2 - Modal Dialog"
			"3 - Floating Window"
			"4 - Plain Box"
			"5 - Shadowed Box"
			"6 - Rounded Window"
			"7 - Global Floating Window"
			"8 - Sheet Window"
			"9 - Metal Window"
			"11 - Modeless Dialog"
		#tag EndEnumValues
	#tag EndViewProperty
	#tag ViewProperty
		Name="FullScreen"
		Group="Behavior"
		InitialValue="False"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="FullScreenButton"
		Visible=true
		Group="Frame"
		InitialValue="False"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="HasBackColor"
		Visible=true
		Group="Background"
		InitialValue="False"
		Type="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Height"
		Visible=true
		Group="Size"
		InitialValue="400"
		Type="Integer"
	#tag EndViewProperty
	#tag ViewProperty
		Name="ImplicitInstance"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Interfaces"
		Visible=true
		Group="ID"
		Type="String"
		EditorType="String"
	#tag EndViewProperty
	#tag ViewProperty
		Name="LiveResize"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="MacProcID"
		Group="OS X (Carbon)"
		InitialValue="0"
		Type="Integer"
	#tag EndViewProperty
	#tag ViewProperty
		Name="MaxHeight"
		Visible=true
		Group="Size"
		InitialValue="32000"
		Type="Integer"
	#tag EndViewProperty
	#tag ViewProperty
		Name="MaximizeButton"
		Visible=true
		Group="Frame"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="MaxWidth"
		Visible=true
		Group="Size"
		InitialValue="32000"
		Type="Integer"
	#tag EndViewProperty
	#tag ViewProperty
		Name="MenuBar"
		Visible=true
		Group="Menus"
		Type="MenuBar"
		EditorType="MenuBar"
	#tag EndViewProperty
	#tag ViewProperty
		Name="MenuBarVisible"
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="MinHeight"
		Visible=true
		Group="Size"
		InitialValue="64"
		Type="Integer"
	#tag EndViewProperty
	#tag ViewProperty
		Name="MinimizeButton"
		Visible=true
		Group="Frame"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="MinWidth"
		Visible=true
		Group="Size"
		InitialValue="64"
		Type="Integer"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Name"
		Visible=true
		Group="ID"
		Type="String"
		EditorType="String"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Placement"
		Visible=true
		Group="Behavior"
		InitialValue="0"
		Type="Integer"
		EditorType="Enum"
		#tag EnumValues
			"0 - Default"
			"1 - Parent Window"
			"2 - Main Screen"
			"3 - Parent Window Screen"
			"4 - Stagger"
		#tag EndEnumValues
	#tag EndViewProperty
	#tag ViewProperty
		Name="Resizeable"
		Visible=true
		Group="Frame"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Super"
		Visible=true
		Group="ID"
		Type="String"
		EditorType="String"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Title"
		Visible=true
		Group="Frame"
		InitialValue="Untitled"
		Type="String"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Visible"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType="Boolean"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Width"
		Visible=true
		Group="Size"
		InitialValue="600"
		Type="Integer"
	#tag EndViewProperty
#tag EndViewBehavior
