#tag Module
Protected Module common
	#tag Method, Flags = &h0
		Sub ConfigLoad()
		  
		  Dim objINI As INI
		  
		  ' Create INI object.
		  '
		  objINI = New INI(gobjINI_File)
		  
		  ' Load configuration.
		  '
		  objINI.Load
		  
		  ' DAEMON settings.
		  '
		  gbooConfig_Daemonize = objINI.Get("DAEMON", "daemonize", True)
		  gintConfig_PollingFrequency = objINI.Get("DAEMON", "polling_frequency_ms", 1000)
		  gstrConfig_ShutdownCommand = objINI.Get("DAEMON", "shutdown_command", "sudo poweroff")
		  
		  ' GPIO settings.
		  '
		  gintConfig_PinShutdownRequest = objINI.Get("GPIO", "pin_shutdown_request", 24)
		  
		  ' Destroy INI object.
		  '
		  objINI = Nil
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function Repeat(s As String, n As Integer) As String
		  
		  Dim strTemp As String
		  
		  If n <= 0 Then Return ""
		  If n  = 1 Then Return s
		  
		  strTemp = ""
		  For Index As Integer = 1 To n
		    strTemp = strTemp + s
		  Next Index
		  
		  Return strTemp
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub TimerAction(objTimer As Timer)
		  
		  Static WhirlyGig() As String = Array("(|)","(/)","(-)","(\)")
		  Static i As Integer
		  
		  
		  ' Check for a shutdown request on GPIO pin.
		  '
		  If GPIO.DigitalRead(gintConfig_PinShutdownRequest) = GPIO.HIGH Then
		    
		    stdout.WriteLine("")
		    stdout.WriteLine("")
		    stdout.WriteLine("Shutting down...")
		    
		    Dim objShell As Shell = New Shell
		    objShell.Execute(gstrConfig_ShutdownCommand)
		    
		  Else
		    
		    stdout.Write(Repeat(Chr(8), 3))
		    stdout.Write(WhirlyGig(i))
		    stdout.Flush
		    
		    i = i + 1
		    If i = 4 Then i = 0
		    
		  End If
		  
		End Sub
	#tag EndMethod


	#tag Property, Flags = &h0
		gbooConfig_Daemonize As Boolean
	#tag EndProperty

	#tag Property, Flags = &h0
		gintConfig_PinShutdownRequest As Integer
	#tag EndProperty

	#tag Property, Flags = &h0
		gintConfig_PollingFrequency As Integer
	#tag EndProperty

	#tag Property, Flags = &h0
		gobjINI_File As FolderItem = Nil
	#tag EndProperty

	#tag Property, Flags = &h0
		gstrAppName As String
	#tag EndProperty

	#tag Property, Flags = &h0
		gstrAppPath As String
	#tag EndProperty

	#tag Property, Flags = &h0
		gstrConfig_ShutdownCommand As String
	#tag EndProperty


	#tag ViewBehavior
		#tag ViewProperty
			Name="Index"
			Visible=true
			Group="ID"
			InitialValue="-2147483648"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Left"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Name"
			Visible=true
			Group="ID"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Super"
			Visible=true
			Group="ID"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Top"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gstrAppName"
			Group="Behavior"
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gstrAppPath"
			Group="Behavior"
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gintConfig_PinShutdownRequest"
			Group="Behavior"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gbooConfig_Daemonize"
			Group="Behavior"
			Type="Boolean"
		#tag EndViewProperty
		#tag ViewProperty
			Name="gintConfig_PollingFrequency"
			Group="Behavior"
			Type="Integer"
		#tag EndViewProperty
	#tag EndViewBehavior
End Module
#tag EndModule
